.tf:push:
  
  before_script:
    -  |-
      if [ "$CI_DEFAULT_BRANCH" == "$CI_COMMIT_BRANCH" ]
      then
        /usr/bin/env
        export GOOGLE_APPLICATION_CREDENTIALS=$GCP_APPLICATION_CREDENTIALS
      
      elif [ "$CI_COMMIT_BRANCH" == "$BRANCH_DEV" ]
      then
        /usr/bin/env
        export GOOGLE_APPLICATION_CREDENTIALS=$GCP_APPLICATION_CREDENTIALS 
      
      else
        echo "BRANCH NAO DEFINIDA"
      fi

    #- '/usr/bin/env'
    #- 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
    #- 'export GOOGLE_APPLICATION_CREDENTIALS=${GCP_APPLICATION_CREDENTIALS}'
    - cd infrastructure/gcp/db/
    - terraform --version
    - |-
      terraform init -reconfigure 

  image:
    name: hashicorp/terraform:light
    entrypoint: ['']

validar_tf_db:
  stage: validate
  extends: .tf:push
  environment:
    name: production
  script:
  - ls
  - terraform validate
  cache:
    key: terraform
    paths:
    - .terraform
  only:
    changes:  
      - infrastructure/**/db/*

plan_tf_db:
  stage: plan
  extends: .tf:push
  environment:
    name: production
  script:
    - 'export GOOGLE_APPLICATION_CREDENTIALS=${GCP_APPLICATION_CREDENTIALS}'
    - terraform plan
  dependencies:
    - validar_tf_db
  only:
    changes:  
      - infrastructure/**/db/*

apply_tf_db:
  stage: apply
  extends: .tf:push
  environment:
    name: production
  script:
    - 'export GOOGLE_APPLICATION_CREDENTIALS=${GCP_APPLICATION_CREDENTIALS}'
    - terraform apply --auto-approve
  dependencies:
    - plan_tf_db
  when: manual
  only:
    changes:  
      - infrastructure/**/db/*
  
destroy_tf_db:
  stage: destroy
  extends: .tf:push
  environment:
    name: production
  script:
    - 'export GOOGLE_APPLICATION_CREDENTIALS=${GCP_APPLICATION_CREDENTIALS}'
    - terraform destroy --auto-approve
  dependencies:
    - plan_tf_db
  when: manual
  only:
    changes:  
      - infrastructure/**/db/*
